<?php

import('form.FormElement');
import('form.TableColumn');

class Table extends FormElement {

	var $mColumns		= array();
	var $mTColumns		= array();
	var $mData			= null;
	var $mHeaderTitle	= array();
	var $mAutoCreateColumns = false;
	var $mMultiSelect	= false;
	var $mInteractive	= true;
	var $mMultiSelect	= false;
	var $mKeyField		= ""; //  
	var $mIndexesFields	= array(); //      
	var $mBgColor		= "#ffffff";
	var $mBgColorOver	= "#eeeeff";
	var $mBgColorSelect = "#eeeeee";
	var $mWidth			= "";
	var $cClassName		= "Table";
	
	var $mProccessed	= false;
	
	function Table($name,$value="") {
		$this->mName			= $name;
		$this->mValue			= $value;
	}
	
	function setAutoCreateColumns($value=true) {
		$this->mAutoCreateColumns = $value;
	}
	
	function setData(&$data) {
		if (is_array($data)) {
			if (is_array($data[0])) {
				$this->mData = &$data;
			}
		}
	}
	
	function addColumn(&$column) {
	    if ($column!=null) $column->setTable($this);
		$this->mColumns[] = &$column;
	}
	
	
	function setInteractive($value) { $this->mInteractive = $value;}
	function isInteractive() { return $this->mInteractive;}
		
	function setMultiSelect($value) { $this->mMultiSelect = $value;}
	function getMultiSelect() { return $this->mMultiSelect;}
	
	function setWidth($value) { $this->mWidth = $value;}
	function getWidth() { return $this->mWidth;}
	
	function toString() {
		print_r($this);		
	}
	
	function getValueAt($rowindex,$colindex) {
		if (!$this->mProccessed) $this->_process();
		return $this->mData[$rowindex][$this->mIndexesFields[$colindex]];
	}
	
	function getValueAtName($rowindex,$fieldname) {
		if (!$this->mProccessed) $this->_process();
		return $this->mData[$rowindex][$fieldname];
	}
	
	function _process() {
		$this->mProccessed = true;
		
	    if ($this->mInteractive) {
			$tcolumn = new TableColumn("","@");
			if ($this->mMultiSelect) {
				import('form.CBCellRenderer');
				$tcolumn->setRenderer(new CBCellRenderer());
			} else {
				import('form.CRCellRenderer');
				$tcolumn->setRenderer(new CRCellRenderer());
			}
			$tcolumn->setTable($this);
			array_unshift($this->mColumns, $tcolumn);
		}

		if ($this->mAutoCreateColumns && is_array($this->mData[0])) {
			foreach ($this->mData[0] as $key=>$value) {
			    $this->mColumns[] = new TableColumn($key, strtoupper($key) );
		    }
		}
		
		foreach ($this->mColumns as $column) {
			$this->mIndexesFields[] = $column->getField();
			$this->mHeaderTitle[] = $column->getColumnTitle();
    	}
    	
    	if (is_array($this->mData[0]) && (list($key,$value) = each($this->mData[0])) ) {
    		$this->mKeyField = $key;
    	}
	}
	
	function toStringControl() {
		if (!$this->isRenderable()) return "";
		if (!$this->mProccessed) $this->_process();
		$html = "";
		
		if ($this->mInteractive) {
			$html .= $this->_addJavaScript();
		}
		
		$html .= "<table border=\"1\"";
		
		if ($this->mWidth!="") $html .= " width=\"".$this->mWidth."\"";
		
		$html .= ">\n";
		
		if (($this->mInteractive && count($this->mHeaderTitle)>1) || 
			(!$this->mInteractive && count($this->mHeaderTitle)>0)) {
			$html .= "<tr>\n";
			foreach ($this->mHeaderTitle as $title) {
				$html .= "<th>$title</th>\n";
			}
			$html .= "</tr>\n";
		}
		for ($row = 0; $row<count($this->mData); $row++) {
			//$html .= "\n<tr bgcolor=\"".$this->mBgColor."\" onmouseover=\"setPointer(this, '".$this->mBgColorOver."')\" onmouseout=\"setPointer(this, '".$this->mBgColor."')\">\n";
			$html .= "\n<tr bgcolor=\"".$this->mBgColor."\" onmouseover=\"setPointer(this, '".$this->mBgColorOver."')\" onmouseout=\"setPointer(this, null)\">\n";
			for ($col=0; $col<$this->getColumnCount();$col++) {
			    if ((get_class($this->mColumns[$col]->getRenderer()) == 'cbcellrenderer')
			    	|| (get_class($this->mColumns[$col]->getRenderer()) == 'crcellrenderer')) {
			    	// Control elements for rows
				    $html .= $this->mColumns[$col]->renderCell($this->mData[$row][$this->mKeyField],$row,$col);
			    } else {
			        $html .= $this->mColumns[$col]->renderCell($this->getValueAt($row,$col),$row,$col);
			    }
			}
			$html .= "</tr>\n";
		}
		$html .= "</table>";
		return $html;
	}
	
	function getColumnCount() {
	    //return ($this->mAutoCreateColumns ? count($this->mData[0]) : count($this->mColumns));
	    return count($this->mColumns);
	}
	
	function _addJavaScript() {
		$html = "<script>\n";
		$html .= "var rowBgColors;\n";
		$html .= "function setPointer(theRow, thePointerColor) {\n";
    	$html .= "\tif (typeof(theRow.style) == 'undefined' || typeof(theRow.cells) == 'undefined') {\n";
        $html .= "\treturn false;\n\t}\n\n";

        $html .= "\tvar row_cells_cnt = theRow.cells.length;\n";
        
        $html .= "\tif (thePointerColor!=null) {\n";
        $html .= "\trowBgColors = new Array(row_cells_cnt);\n";
    	$html .= "\tfor (var c = 0; c < row_cells_cnt; c++) {\n";
        $html .= "\t\trowBgColors[c]=theRow.cells[c].bgColor;\n\t}\n";
        $html .= "\t}\n";
        
    	$html .= "\tfor (var c = 0; c < row_cells_cnt; c++) {\n";
        $html .= "\t\ttheRow.cells[c].bgColor = thePointerColor;\n\t}\n\n";
        
        $html .= "\tif (thePointerColor==null) {\n";
    	$html .= "\tfor (var c = 0; c < row_cells_cnt; c++) {\n";
        $html .= "\t\ttheRow.cells[c].bgColor=rowBgColors[c];\n\t}\n";
        $html .= "\tdelete rowBgColors;\n";
        $html .= "\t}\n";

	    $html .= "\treturn true;\n}\n";
		$html .= "</script>\n";
		return $html;
	}
}
?>