<?php
  $db = DB::connect(DSN);
  if (!DB::isError($db)) {
  	
	$array_of_days = $period->getAllDays();
	foreach ($array_of_days as $i) {
	     $dt_tmp = $i->toString(DB_DATEFORMAT);
	     $wdates[$dt_tmp] = $i->getDay();
	     $clean_dates[$dt_tmp] = $i->toString();
	     $dates_work[$dt_tmp] = '';
	}
  
    $fields = array();
    $header = array();
    $hkeys  = array();
  
    array_push ($fields, 'al.al_date');
    array_push ($header, $i18n->getKey("form.report.th.date"));
    array_push ($hkeys, 'date');
    
    if ($user->isManager()) {
      array_push ($fields, 'u.u_name');
      array_push ($header, $i18n->getKey("form.report.th.empllist"));
      array_push ($hkeys, 'user');
    }
    if ($bean->getAttribute("chproject") || $bean->getAttribute("groupby")=="project") {
      array_push ($fields, 'p.p_name');
      array_push ($header, $i18n->getKey("form.report.th.project"));
      array_push ($hkeys, 'project');
    }
    if ($bean->getAttribute("chactivity") || $bean->getAttribute("groupby")=="activity") {
      array_push ($fields, 'a.a_name');
      array_push ($header, $i18n->getKey("form.report.th.activity"));
      array_push ($hkeys, 'activity');
    }
    if ($bean->getAttribute("chstart")) {
      array_push ($fields, "TIME_FORMAT(al.al_from, '%k:%i')");
      array_push ($header, $i18n->getKey("form.report.th.start"));
      array_push ($hkeys, 'start');
    }
    if ($bean->getAttribute("chfinish")) {
      array_push ($fields, "TIME_FORMAT(sec_to_time(time_to_sec(al.al_from) + time_to_sec(al.al_duration)), '%k:%i')");
      array_push ($header, $i18n->getKey("form.report.th.finish"));
      array_push ($hkeys, 'finish');
    }
    if ($bean->getAttribute("chduration")) {
      array_push ($fields, "TIME_FORMAT(al.al_duration, '%k:%i')");
      array_push ($header, $i18n->getKey("form.report.th.duration"));
      array_push ($hkeys, 'duration');
    }
    if ($bean->getAttribute("chnote")) {
      array_push ($fields, 'al.al_comment');
      array_push ($header, $i18n->getKey("form.report.th.note"));
      array_push ($hkeys, 'note');
    }

   	$q_selproject = ($bean->getAttribute("project") ? " and al.al_project_id = ".$bean->getAttribute("project") : "");
   	$q_selact = ($bean->getAttribute("activity") ? " and al.al_activity_id = ".$bean->getAttribute("activity") : "");
   	
  	$sort_key = (!$bean->getAttribute("groupby") ? "date" : $bean->getAttribute("groupby"));
	$field_list = array_flip($hkeys);
	foreach($field_list as $k=>$v) $empty[$k] = '';
	
	switch ($sort_key) {
        case "user": $group_field = "u.u_name"; break;
        case "project": $group_field = "p.p_name"; break;
        case "activity": $group_field = "a.a_name"; break;
        default: $group_field = "";
    }

    $current_project_name = "";
    $current_activity_name = "";
    
    // db query
    if ($bean->getAttribute("chproject") && $bean->getAttribute("project")) {
    	$sth = $db->prepare("select p.p_name from projects p, project_status_list psl ".
    			"where p.p_id=".$bean->getAttribute("project")." and psl.psl_id=p.p_status and psl.psl_hidden=0");
    	$rc = $db->execute($sth);
    	if (DB::isError($rc) == 0) {
      		if ($val = $rc->fetchRow()) {
        		$current_project_name = $val[0];
      		}
    	}
    }
   	if ($bean->getAttribute("chactivity") && $bean->getAttribute("activity")) {
   		$sth = $db->prepare("select a.a_name
                from activities a, activity_status_list asl
                where a.a_id=".$bean->getAttribute("activity")." and asl.asl_id=a.a_status");
    	$rc = $db->execute($sth);
    	if (DB::isError($rc) == 0) {
      		if ($val = $rc->fetchRow()) {
        		$current_activity_name = $val[0];
      		}
    	}
   	}
   	
    $rows = array(); 
    $fill_date = array(); 
    if ($user->isManager()) {
      $sel_str = "select " . join (', ', $fields) . " from activity_log al, projects p, activities a, users u where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id in (".$userlist.") and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id and u.u_id = al.al_user_id order by u.u_name, al.al_date, al.al_from";
    } else {
      $sel_str = "select " . join (', ', $fields) . " from activity_log al, projects p, activities a where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id = ".$user->getUserId()." and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id order by al.al_date, al.al_from";
    }
//print $sel_str;
    $sth = $db->prepare($sel_str);
    $rc = $db->execute($sth);
    if (DB::isError($rc) == 0) {
      while ($val = $rc->fetchRow()) {
        $row = array();
      	foreach ($hkeys as $fn) {
      		$row[$fn] = $val[$field_list[$fn]];
      	}
      	$row["sortkey"] = @$row[$sort_key];
      	$fill_date[] = array('sortkey'=>@$row[$sort_key],'date'=>$val[0]);
   	    $rows[] = $row;
      }
    } else {
      print "<font color=\"red\">Database processing error 1/Report generating error/</font><br>\n";
      die();
    }

    // get subresults
    $sub_summary = array();
    if ($group_field) {
        if ($user->isManager()) {
          $sel_str = "select $group_field,TIME_FORMAT(sec_to_time(sum(time_to_sec(al.al_duration))), '%k:%i') from activity_log al, projects p, activities a, users u where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id in (".$userlist.") and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id and u.u_id = al.al_user_id group by $group_field";
        } else {
          $sel_str = "select $group_field,TIME_FORMAT(sec_to_time(sum(time_to_sec(al.al_duration))), '%k:%i') from activity_log al, projects p, activities a where al.al_date >= '".$period->getBeginDate(DB_DATEFORMAT)."' and al.al_date <= '".$period->getEndDate(DB_DATEFORMAT)."' and al.al_user_id = ".$user->getUserId()." and p.p_id = al.al_project_id". $q_selproject . $q_selact. " and a.a_id = al.al_activity_id group by $group_field";
        }
        $sth = $db->prepare($sel_str);
        $rc = $db->execute($sth);
        if (DB::isError($rc) == 0) {
          while ($val = $rc->fetchRow()) {    
              $sub_summary[$val[0]] = $val[1];
          }
        } else {
          print "<font color=\"red\">Database processing error 2/Report generating error/</font><br>\n";
        }
    } else {
        $sub_summary['common'] = '1';
    }
    
    if ($bean->getAttribute("chshowidle") && isset($user)) {
    	
    	if ($sort_key=='user'&& ($bean->getAttribute('user')==null)) {
    		import("UserHelper");
    		$users = UserHelper::findAllUsers($user);
    		$arr = $bean->getAttribute('users');
    		foreach ($users as $user_it) {
    			if (is_array(@$arr) && in_array($user_it["u_id"],@$arr)) {
	    			if (!in_array($user_it["u_name"],array_keys($sub_summary))) {
	    				$sub_summary[$user_it["u_name"]] = 0;
	    			}
    			}
    		}
    	}

    	if ($sort_key=='project' && ($bean->getAttribute('project')==null)) {
    		import("ProjectHelper");
    		$projects = ProjectHelper::findAllProjects($user);
    		foreach ($projects as $project) {
    			if (!in_array($project["p_name"],array_keys($sub_summary))) {
    				$sub_summary[$project["p_name"]] = 0;
    			}
    		}
    	}
    	if ($sort_key=='activity' && ($bean->getAttribute('activity')==null)) {
    		import("ActivityHelper");
    		$activities = ActivityHelper::findAllActivity($user);
    		foreach ($activities as $activity) {
    			if (!in_array($activity["a_name"],array_keys($sub_summary))) {
    				$sub_summary[$activity["a_name"]] = 0;
    			}
    		}
    	}
    	
    }
    
    //build dates period for each subsummary
	if ($bean->getAttribute("chshowidle")) {
	    foreach ($sub_summary as $k=>$v) {
            foreach ($array_of_days as $i) {
              $index = $i->toString(DB_DATEFORMAT);
              $row = $empty;
    		  $row["date"] = $index;
    		  $row["sortkey"] = ($sort_key=='date' ? $row[$sort_key] : $k);
              $toadd = true;
              foreach ($fill_date as $key) {
                  if ($key['date']==$index && $key['sortkey']==$row["sortkey"]) {
                      $toadd = false;
                  }
              }
              if ($toadd) {
                 $rows[] = $row;
                 $fill_date[] = array('date'=>$index,'sortkey'=>$row["sortkey"]);
              }
            }
	    }
    }
    
    
    // sort by keys
    $rows = mu_sort($rows, "sortkey,date");
  } //db
  else 
  	print $i18n->getKey("errors.db_error"); 
?>